<template>
  <v-app>
    <!-- dashboard สำหรับ 11 โรงพยาบาล  --> <!-- dashboard สำหรับ 11 โรงพยาบาล  --> <!-- dashboard สำหรับ 11 โรงพยาบาล  -->
    
    <!-- v-app-bar -->
    <v-app-bar app color="#428bca" dark>
      <img src="../../assets/Asset7.png" style="width: 10.5%" class="mt-1" />
      <v-toolbar-title>
        <span style="margin-top: 1%" class="ml-2">
          <span style="font-size: 30px">:</span>
          <span class="ml-1"> AI - CXR SCREENING v 3.1.0</span>
        </span>
      </v-toolbar-title>
    </v-app-bar>
    <!-- v-app-bar -->

    <!-- spinner -->
    <div class="text-center">
      <v-dialog v-model="dialog_loader" hide-overlay persistent width="300">
        <v-card color="#428bca" dark>
          <v-card-text class="text-center" style="color: white">
            Wait . . .
            <v-progress-linear
              indeterminate
              color="white"
              class="mb-0"
            ></v-progress-linear>
          </v-card-text>
        </v-card>
      </v-dialog>
    </div>
    <!-- spinner -->

    <!-- ภาพรวมรายเดือน -->
    <v-container>
      <v-card elevation="0">
        <v-card-title><h1>Dashboard</h1></v-card-title>
        <v-card-text class="mt-3">
          <v-row>
            <v-col>
              <span style="font-size:20px">
                ภาพรวมรายเดือนของแต่ละโรงพยาบาล
              </span>
            </v-col>
            <v-spacer></v-spacer>
            <v-col>
              <v-dialog ref="dialog" v-model="modal" :return-value.sync="date" persistent width="290px">
                <template v-slot:activator="{ on, attrs }">
                  <v-text-field
                    v-model="show_select_date"
                    label="Select year Select month"
                    append-icon="mdi-calendar"
                    @click:append="modal = true"
                    readonly
                    v-bind="attrs"
                    v-on="on"
                    outlined
                    dense
                  ></v-text-field>
                </template>
                <v-date-picker v-model="select_date" scrollable type="month">
                  <v-spacer></v-spacer>
                  <v-btn text color="primary" @click="cancel_filter()">Cancel</v-btn>
                  <v-btn text color="primary" @click="submit_filter()">OK</v-btn>
                </v-date-picker>
              </v-dialog>
              <!-- </v-container> -->
            </v-col>
          </v-row>
        </v-card-text>
        <div id="chart">
          <apexchart
            type="bar"
            :options="chartOptions"
            :series="series"
          ></apexchart>
        </div>

        <!-- <div class="mt-5">
          <v-data-table
            :headers="headers"
            :items="itemsWithIndex"
            :footer-props="{
              itemsPerPageOptions: [5, -1]
            }"
            :items-per-page="5"
            class="elevation-2"
          >
            <template v-slot:item.Abnormal="{ item }">
              <span style="color:rgb(0, 124, 218)"
                ><b>{{ item.Abnormal }}</b></span
              >
            </template>

            <template v-slot:item.Tuberculosis="{ item }">
              <span style="color:orange"
                ><b>{{ item.Tuberculosis }}</b></span
              >
            </template>
          </v-data-table>
        </div> -->

        <!-- ภาพรวมรายปี -->

        <!-- <v-card-text class="mt-3">
          <v-row>
            <v-col>
              <span style="font-size:20px">
                ภาพรวมรายปีของแต่ละโรงพยาบาล
              </span>
            </v-col>

            <v-spacer></v-spacer>

            <v-col>
              <v-select
                type="year"
                class="pa-0"
                :items="items_array_year"
                v-model="select_year"
                label="select year for filter"
                dense
                outlined
              ></v-select>
            </v-col>
          </v-row>
        </v-card-text>

        <div id="chart">
          <apexchart
            type="line"
            height="550"
            width="1200"
            :options="chartOptionsYear"
            :series="seriesB"
          ></apexchart>
        </div> -->
      </v-card>
    </v-container>
    <!-- ภาพรวมรายเดือน -->
  </v-app>
</template>

<script>
import moment from "moment";
export default {
  data() {
    return {
      items_array_year: [],
      select_year: new Date().toISOString().substr(0, 10),
      dialog_loader: false,
      hopital_name: [],
      date: "",
      moment,
      modal: false,
      show_select_date: "",
      select_date: new Date().toISOString().substr(0, 10),
      data_tb: [],
      data_abnormal: [],
      count_tb: 0,
      count_abnormal: 0,
      series: [
        {
          name: "Abnormal",
          data: []
        },
        {
          name: "Tuberculosis",
          data: []
        }
      ],
      seriesB: [],
      chartOptions: {
        chart: {
          height: 450,
          type: "bar",
          // stacked: true,
          // stackType: "100%",
          // toolbar: {
          //   show: true
          // },
          zoom: {
            enabled: true
          }
        },
        responsive: [
          {
            options: {
              legend: {
                position: "bottom",
                offsetX: -10,
                offsetY: 0
              }
            }
          }
        ],
        // colors: colors,
        plotOptions: {
          bar: {
            Width: "50%",
            horizontal: false,
            dataLabels: {
              position: "top"
            }
          }
        },
        dataLabels: {
          formatter: function(val) {
            return val ? val : "";
          },
          enabled: true,
          offsetY: -25,
          style: {
            fontSize: "12px",
            colors: ["rgb(0, 0, 0)"]
          }
        },
        xaxis: {
          categories: [],
          labels: {
            rotate: -30,
            style: {
              fontSize: "14px"
            }
          }
        },
        legend: {
          show: true,
          showForSingleSeries: true,
          customLegendItems: ["Actual", "Expected"],
          position: "right",
          offsetY: -10,
          markers: {
            fillColors: ["rgb(0, 143, 251)", "rgb(254, 176, 25)"]
          }
        },
        fill: {
          opacity: 1,
          colors: ["rgb(0, 143, 251)", "rgb(254, 176, 25)"]
        },
        yaxis: {
          title: {
            text: "U S E  F I L M"
          }
        }
      },
      ///// ====>  year <==== /////
      chartOptionsYear: {
        chart: {
          height: 350,
          type: "line",
          toolbar: {
            show: false
          },
          zoom: {
            enabled: true
          }
        },
        colors: [
          "#D98880",
          "#F1948A",
          "#C39BD3",
          "#BB8FCE",
          "#5499C7",
          "#F4D03F"
        ],
        stroke: {
          curve: "smooth",
          width: 1
        },
        responsive: [
          {
            options: {
              legend: {
                position: "bottom",
                offsetX: -10,
                offsetY: 0
              }
            }
          }
        ],
        plotOptions: {
          bar: {
            Width: "50%",
            horizontal: false,
            dataLabels: {
              position: "top"
            }
          }
        },
        dataLabels: {
          enabled: true
        },
        xaxis: {
          categories: [
            "มกราคม",
            "กุมภาพันธ์",
            "มีนาคม",
            "เมษายน",
            "พฤษภาคม",
            "มิถุนายน",
            "กรกฎาคม",
            "สิงหาคม",
            "กันยายน",
            "ตุลาคม",
            "พฤศจิกายน",
            "ธันวาคม"
          ],
          labels: {
            rotate: -30,
            style: {
              fontSize: "14px"
            }
            // hideOverlappingLabels: false
          }
        },
        // legend: {
        //   show: true,
        //   showForSingleSeries: true,
        //   customLegendItems: ["Actual", "Expected"],
        //   position: "right",
        //   offsetY: -50,
        //   markers: {
        //     fillColors: ["rgb(0, 143, 251)", "rgb(254, 176, 25)"]
        //   }
        // },
        legend: {
          show: true,
          position: "top",
          horizontalAlign: "center",
          floating: true,
          offsetX: 10,
          offsetY: 0,
          containerMargin: {
            top: 30,
            bottom: 30
          }
        },
        fill: {
          opacity: 1
          // colors: ["rgb(0, 143, 251)", "rgb(254, 176, 25)"]
        },
        yaxis: {
          title: {
            text: "U S E  F I L M"
          }
        }
      },
      headers: [
        {
          text: "ลำดับ",
          align: "start",
          sortable: true,
          value: "index"
        },
        {
          text: "ชื่อโรงพยาบาล",
          value: "hospital_name",
          align: "start",
          sortable: false
        },
        {
          text: "จำนวนฟิล์มที่ใช้ (รายเดือน)",
          value: "used_film",
          align: "center",
          sortable: false
        },
        {
          text: "Abnormal",
          value: "Abnormal",
          align: "center",
          sortable: false
        },
        {
          text: "Tuberculosis",
          value: "Tuberculosis",
          align: "center",
          sortable: false
        }
      ],
      data_hospital: []
    };
  },

  watch: {
    select_year(val) {
      console.log("select_year", val);
      this.get_year_dashboard();
    }
  },

  computed: {
    itemsWithIndex() {
      return this.data_hospital.map((data, index) => ({
        ...data,
        index: index + 1
      }));
    }
  },

  mounted() {
    this.select_date = moment(this.select_date).format("YYYY-MM");
    console.log("select-date-mounted", this.select_date);
    this.show_select_date = this.select_date;
    this.get_dashboard();
    // ===> select year <=== //
    this.select_year = moment(this.select_year).format("YYYY");
    let array_year = [];
    for (let index = this.select_year - 3; index <= this.select_year; index++) {
      array_year.push(String(index));
    }
    array_year.sort();
    array_year.sort(function(a, b) {
      return b - a;
    });
    this.items_array_year = array_year;
    this.select_year = moment(this.select_year).format("YYYY");
    // this.get_year_dashboard();
  },

  methods: {
    get_dashboard() {
      this.count_array = [];
      this.hopital_name = [];
      this.data_tb = [];
      this.data_abnormal = [];
      this.count_abnormal = 0;
      this.count_tb = 0;
      this.dialog_loader = true;
      this.axios
        .get(
          process.env.VUE_APP_API +
            "/api/v3/film_overview/SummaryHospital_filmoverview?hospital_id=" +
            [
              "74a67164-83d8-4fad-8853-9117143952ce",
              "39587177-336d-4aa3-af34-52550ebf5832",
              "a6a3771c-ccc3-4dbb-b11e-9a13beb0a45d",
              "96c8af7c-2f27-495c-85ca-58e3ad880419",
              "b5309095-1ab3-40c7-a378-f219e50b29c8",
              "72a54695-6120-41a3-a7f8-4017caafc674",
              "bb787bf8-7b87-4b3e-befe-2bbe3657fe45",
              "78d7a110-3632-4ed6-a550-dae36bffc695",
              "9af6f996-f480-4ac8-9ad6-75e06fd9d670",
              "afca0970-94d6-481f-9aa7-dfe33f4c599e",
              "f0293af4-fd51-4531-9321-fd0e28395e71"
              ////////////////////////////////////////////////
              // "e591d940-de4d-4a17-9cdd-59469198d60b",
              // "4eee8faf-eacf-492a-8356-65dc57049416",
              // "cf156502-c07e-430c-b442-2e473bfee3f4",
              // "350ad38c-587c-4bb1-962b-264346a43541",
              // "62ba8b82-2321-40a7-8f6b-9fddb3d25e8d",
              // "ec302f7a-f6a9-44db-a8a2-356e9773c027",
              // "16dddaa3-f70e-4b5c-b07b-96a23b652af7",
              // "159826a2-94e8-4bb5-9129-95afdc037142",
              // "3e77afa4-d884-428e-9450-555bdf9d0747",
              // "471ac8e1-ac6d-4980-91bb-d15e19bd0d19",
              // "3d5f8e9d-0c9c-433a-8625-87595ca9068a"
            ] +
            "&date_time=" +
            this.select_date +
            "-01"
        )
        .then(response => {
          this.dialog_loader = false;
          // console.log("response", response.data.data);
          console.log("response", response.data);
          for (const property in response.data.data) {
            // console.log(`${property}: ${response.data.data[property]}`);
            // console.log(typeof response.data.data[property]);
            if (typeof response.data.data[property] === "number") {
              this.count_array.push(response.data.data[property]);
              // console.log("count", this.count_array);
            } else {
              console.log(`${property}`);
              this.data_hospital.push({ hospital_name: property });
              // console.log("property[]", response.data.data[property]);
              if (response.data.data[property].length == 0) {
                this.data_tb.push(0);
                this.data_abnormal.push(0);
              } else {
                for (let index = 0;index < response.data.data[property].length;index++) {
                  if (/Tuberculosis/.test(response.data.data[property][index].list_status_disease)) {
                    this.count_tb += 1;
                  } else {
                    this.count_abnormal += 1;
                  }
                }
                this.data_tb.push(this.count_tb);
                this.data_abnormal.push(this.count_abnormal);
                this.count_abnormal = 0;
                this.count_tb = 0;
              }
              this.hopital_name.push(property);
            }
            console.log("data_hospital", this.data_hospital);
          }

          this.chartOptions = {
            ...this.chartOptions,
            ...{
              xaxis: {
                categories: this.hopital_name
              }
            }
          };

          this.series = [
            {
              name: "Abnormal",
              data: this.data_abnormal
            },
            {
              name: "Tuberculosis",
              data: this.data_tb
            }
          ];
          // count = > abnormal
          for (let index = 0; index < this.data_abnormal.length; index++) {
            // console.log("data_abnormal", this.data_abnormal[index]);
            this.data_hospital[index]["Abnormal"] = this.data_abnormal[index];
          }
          // count => TB
          for (let index = 0; index < this.data_tb.length; index++) {
            // console.log("data_tb", this.data_tb[index]);
            this.data_hospital[index]["Tuberculosis"] = this.data_tb[index];
          }
          // count => use_all_film
          for (let index = 0; index < this.data_hospital.length; index++) {
            console.log("data_hospital", this.data_hospital[index]);
            this.data_hospital[index]["used_film"] = this.data_hospital[index]["Abnormal"] + this.data_hospital[index]["Tuberculosis"];
          }
          console.log("final-data_hospital:", this.data_hospital);
        })
        .catch(error => {
          this.dialog_loader = false;
          console.log(error);
        });
    },

    get_year_dashboard() {
      this.dialog_loader = true;
      console.log("get_year_dashboard");
      this.axios
        .get(
          process.env.VUE_APP_API +
            "/api/v3/film_overview/SummaryOfYear_filmoverview?hospital_id=" +
            [
              "74a67164-83d8-4fad-8853-9117143952ce",
              "39587177-336d-4aa3-af34-52550ebf5832",
              "74a67164-83d8-4fad-8853-9117143952ce",
              "39587177-336d-4aa3-af34-52550ebf5832",
              "a6a3771c-ccc3-4dbb-b11e-9a13beb0a45d",
              "96c8af7c-2f27-495c-85ca-58e3ad880419",
              "b5309095-1ab3-40c7-a378-f219e50b29c8",
              "72a54695-6120-41a3-a7f8-4017caafc674",
              "bb787bf8-7b87-4b3e-befe-2bbe3657fe45",
              "78d7a110-3632-4ed6-a550-dae36bffc695",
              "9af6f996-f480-4ac8-9ad6-75e06fd9d670",
              "afca0970-94d6-481f-9aa7-dfe33f4c599e",
              "f0293af4-fd51-4531-9321-fd0e28395e71"
              ///////////////////////////////////////////////
              // "e591d940-de4d-4a17-9cdd-59469198d60b",
              // "4eee8faf-eacf-492a-8356-65dc57049416",
              // "cf156502-c07e-430c-b442-2e473bfee3f4",
              // "350ad38c-587c-4bb1-962b-264346a43541",
              // "62ba8b82-2321-40a7-8f6b-9fddb3d25e8d",
              // "ec302f7a-f6a9-44db-a8a2-356e9773c027",
              // "16dddaa3-f70e-4b5c-b07b-96a23b652af7",
              // "159826a2-94e8-4bb5-9129-95afdc037142",
              // "3e77afa4-d884-428e-9450-555bdf9d0747",
              // "471ac8e1-ac6d-4980-91bb-d15e19bd0d19",
              // "3d5f8e9d-0c9c-433a-8625-87595ca9068a"
            ] +
            "&date_time=" +
            this.select_year
        )
        .then(response => {
          this.dialog_loader = false;
          this.seriesB = response.data.data;
          console.log("seriesB", this.seriesB);
          console.log(response.data.data);
        })
        .catch(error => {
          this.dialog_loader = false;
          console.log(error);
        });
    },

    cancel_filter() {
      this.modal = false;
    },
    submit_filter() {
      this.show_select_date = this.select_date;
      this.modal = false;
      console.log("select_date", this.select_date);
      this.get_dashboard();
    }
  }
};
</script>

<style></style>
